package com.example.springbootdemo.config;

import com.rabbitmq.client.Channel;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Exchange;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.QueueBinding;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.amqp.support.AmqpHeaders;
import org.springframework.messaging.handler.annotation.Headers;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.Map;

@Component
public class CustomRabbitListener {
//    @org.springframework.amqp.rabbit.annotation.RabbitListener(queues = "crm_foot_info_14049")
//    public void a(Message message) {
//        System.out.println(message);
//    }
    @RabbitListener (queues = RabbitMQConfiguration.dealQueueOrder)
    public void process(String order, Message message, @Headers Map<String, Object> headers, Channel channel) throws IOException {
        System.out.println("死信ie zh++"+ order);
        Long l = (Long)headers.get(AmqpHeaders.DELIVERY_TAG);
        channel.basicAck(l,false);
    }
    @RabbitListener (queues = RabbitMQConfiguration.orderQueue)
    public void orderQueue(String order, Message message, @Headers Map<String, Object> headers, Channel channel) throws IOException {
        System.out.println("orderQueue收到隊列消息並進行拒絕"+ order);
        Long l = (Long)headers.get(AmqpHeaders.DELIVERY_TAG);
        channel.basicNack(l,false,false);
    }


}
