package com.example.springbootdemo.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.example.springbootdemo.entity.FootScanEntity;
import com.example.springbootdemo.entity.FootScanGroup;
import com.example.springbootdemo.form.PostForm;
import com.example.springbootdemo.mapper.FootScanMapper;
import com.example.springbootdemo.query.DateQuery;
import com.example.springbootdemo.service.FootScanGroupService;
import com.example.springbootdemo.service.FootScanService;
import com.example.springbootdemo.zxyTeST.sql.dao.ArmGrabRepository;
import com.example.springbootdemo.zxyTeST.sql.dao.ColorRepository;
import com.example.springbootdemo.zxyTeST.sql.entity.ArmGrabEntity;
import com.example.springbootdemo.zxyTeST.sql.entity.Color;
import com.example.util.MailUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.*;

import javax.mail.Address;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.MimeMessage;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.Properties;
import java.util.concurrent.ConcurrentHashMap;
import java.util.logging.SimpleFormatter;

@RestController
public class HelloController {
    @Autowired
    ColorRepository colorRepository;
    @Autowired
    ArmGrabRepository armGrabRepository;
    @Autowired
    JdbcTemplate jdbcTemplate;
    @Autowired
    FootScanService footScanService;
    @Autowired
    FootScanGroupService footScanGroupService;
    @Autowired
    FootScanMapper footScanMapper;
    @Autowired
    MailUtil mailUtil;

    @RequestMapping("/hello")
    public void hello() {
        List<Color> listColors = colorRepository.findByColorId(2314);
        for (Color color:listColors) {
            System.out.println("color_name="+color.getColorName()+"    color_id="+color.getColorId());
        }
        List<ArmGrabEntity> armGrabEntityList = armGrabRepository.findByArmGrabId(1);
        for (ArmGrabEntity armGrabEntity:armGrabEntityList) {
            System.out.println("id="+armGrabEntity.getArmGrabId()+"    device_code="+armGrabEntity.getDeviceCode());
        }
    }
    @RequestMapping("/jdbc")
    public String jdbc() {
        String sql = "select color_name from wb_tbl_color where color_id = ? and color_type = ?";
        try {
            String color_name = jdbcTemplate.queryForObject(
                    sql, new Object[] { 2314, 1 }, String.class);
            return color_name;
        } catch (EmptyResultDataAccessException e) {
            return "hha我snull";
        }

    }
    @RequestMapping("mybatis")
    public FootScanEntity getById(@RequestParam("foot_scan_id") Long foot_scan_id) {
        return footScanService.getFootScanById(foot_scan_id);

    }
    @RequestMapping("mybatis1")
    public FootScanGroup getFootScanGroup(@RequestParam("foot_scan_group_id") Long foot_scan_group_id) {
        return footScanGroupService.getById(foot_scan_group_id);
    }
    @RequestMapping(value = "/mybatis2",method = RequestMethod.POST)
    public FootScanGroup addFootScanGroup(@RequestBody FootScanGroup footScanGroup) {
        footScanGroupService.save(footScanGroup);
        return footScanGroup;
    }
    @RequestMapping("mybatis3")
    public FootScanEntity getFootScanInfo(@RequestParam("foot_scan_id") Long foot_scan_id) {
        return  footScanMapper.queryFootScanInfo(foot_scan_id);
    }
    //@RequestMapping("mybatis4")
//    public List<FootScanEntity> getFootScanListPage() {
//        Page<FootScanEntity> footScanEntityPage = new Page<>(1,20);
//        footScanService.page(footScanEntityPage,null);
//        return  footScanEntityPage.getRecords();
//    }
    @RequestMapping("testDate")
    public String testDate(DateQuery dateQuery) {
        SimpleDateFormat simpleFormatter = new SimpleDateFormat("今天是 yyyy 年 MM 月 dd 日 E HH 点 mm 分 ss 秒");
        return simpleFormatter.format(dateQuery.getDate());
    }
    @PostMapping("postTest")
    public void testPost(@RequestBody PostForm postForm) {
        ConcurrentHashMap<String, String> stringStringConcurrentHashMap = new ConcurrentHashMap<>();
        stringStringConcurrentHashMap.put("1","123");
        System.out.println(postForm.getName());
    }

    @RequestMapping("testMail")
    public void testMail() {
        Properties properties = new Properties();
        properties.setProperty("mail.transport.protocol", "smtp");   // 使用的协议（JavaMail规范要求）
        properties.setProperty("mail.smtp.host", "smtp.exmail.qq.com");   // 发件人的邮箱的 SMTP 服务器地址
        properties.setProperty("mail.smtp.auth", "true");
        Session session = Session.getDefaultInstance(properties);
        session.setDebug(true);                                 // 设置为debug模式, 可以查看详细的发送 log
        try {
            MimeMessage message = mailUtil.createMimeMessage(session, "software@semsx.com",
                    "771799477@qq.com,1152047207@qq.com");
            Transport transport = session.getTransport();
            transport.connect("software@semsx.com","RNDmdjNarRkqg4ge");
            Address[] allRecipients = message.getAllRecipients();
        //    transport.sendMessage(message,message.getAllRecipients());
            transport.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }


}

